diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py ns-3.34/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py
--- ns-3.33/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
@@ -85,6 +85,8 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress [class]
     module.add_class('Ipv4InterfaceAddress', import_from_module='ns.internet')
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e [enumeration]
@@ -97,6 +99,8 @@
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -503,10 +507,12 @@
     register_Ns3Inet6SocketAddress_methods(root_module, root_module['ns3::Inet6SocketAddress'])
     register_Ns3InetSocketAddress_methods(root_module, root_module['ns3::InetSocketAddress'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4InterfaceAddress_methods(root_module, root_module['ns3::Ipv4InterfaceAddress'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv4RoutingHelper_methods(root_module, root_module['ns3::Ipv4RoutingHelper'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
@@ -1524,6 +1530,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4InterfaceAddress_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1855,6 +1873,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -1930,6 +1953,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1950,6 +1985,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
@@ -3571,8 +3611,8 @@
 def register_Ns3Ipv4NixVectorHelper_methods(root_module, cls):
     ## ipv4-nix-vector-helper.h (module 'nix-vector-routing'): ns3::Ipv4NixVectorHelper::Ipv4NixVectorHelper() [constructor]
     cls.add_constructor([])
-    ## ipv4-nix-vector-helper.h (module 'nix-vector-routing'): ns3::Ipv4NixVectorHelper::Ipv4NixVectorHelper(ns3::Ipv4NixVectorHelper const & arg0) [constructor]
-    cls.add_constructor([param('ns3::Ipv4NixVectorHelper const &', 'arg0')])
+    ## ipv4-nix-vector-helper.h (module 'nix-vector-routing'): ns3::Ipv4NixVectorHelper::Ipv4NixVectorHelper(ns3::Ipv4NixVectorHelper const & o) [constructor]
+    cls.add_constructor([param('ns3::Ipv4NixVectorHelper const &', 'o')])
     ## ipv4-nix-vector-helper.h (module 'nix-vector-routing'): ns3::Ipv4NixVectorHelper * ns3::Ipv4NixVectorHelper::Copy() const [member function]
     cls.add_method('Copy', 
                    'ns3::Ipv4NixVectorHelper *', 
@@ -3583,6 +3623,10 @@
                    'ns3::Ptr< ns3::Ipv4RoutingProtocol >', 
                    [param('ns3::Ptr< ns3::Node >', 'node')], 
                    is_const=True, is_virtual=True)
+    ## ipv4-nix-vector-helper.h (module 'nix-vector-routing'): void ns3::Ipv4NixVectorHelper::PrintRoutingPathAt(ns3::Time printTime, ns3::Ptr<ns3::Node> source, ns3::Ipv4Address dest, ns3::Ptr<ns3::OutputStreamWrapper> stream, ns3::Time::Unit unit=::ns3::Time::Unit::S) [member function]
+    cls.add_method('PrintRoutingPathAt', 
+                   'void', 
+                   [param('ns3::Time', 'printTime'), param('ns3::Ptr< ns3::Node >', 'source'), param('ns3::Ipv4Address', 'dest'), param('ns3::Ptr< ns3::OutputStreamWrapper >', 'stream'), param('ns3::Time::Unit', 'unit', default_value='::ns3::Time::Unit::S')])
     return
 
 def register_Ns3Object_methods(root_module, cls):
@@ -4021,10 +4065,10 @@
     cls.add_method('SetPriority', 
                    'void', 
                    [param('uint8_t', 'priority')])
-    ## socket.h (module 'network'): void ns3::Socket::SetRecvCallback(ns3::Callback<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> arg0) [member function]
+    ## socket.h (module 'network'): void ns3::Socket::SetRecvCallback(ns3::Callback<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> receivedData) [member function]
     cls.add_method('SetRecvCallback', 
                    'void', 
-                   [param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'arg0')])
+                   [param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'receivedData')])
     ## socket.h (module 'network'): void ns3::Socket::SetRecvPktInfo(bool flag) [member function]
     cls.add_method('SetRecvPktInfo', 
                    'void', 
@@ -6410,6 +6454,11 @@
                    'ns3::TypeId', 
                    [], 
                    is_static=True)
+    ## ipv4-nix-vector-routing.h (module 'nix-vector-routing'): void ns3::Ipv4NixVectorRouting::PrintRoutingPath(ns3::Ptr<ns3::Node> source, ns3::Ipv4Address dest, ns3::Ptr<ns3::OutputStreamWrapper> stream, ns3::Time::Unit unit) const [member function]
+    cls.add_method('PrintRoutingPath', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::Node >', 'source'), param('ns3::Ipv4Address', 'dest'), param('ns3::Ptr< ns3::OutputStreamWrapper >', 'stream'), param('ns3::Time::Unit', 'unit')], 
+                   is_const=True)
     ## ipv4-nix-vector-routing.h (module 'nix-vector-routing'): void ns3::Ipv4NixVectorRouting::SetNode(ns3::Ptr<ns3::Node> node) [member function]
     cls.add_method('SetNode', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/nix-vector-routing/examples/nix-simple.cc ns-3.34/src/nix-vector-routing/examples/nix-simple.cc
--- ns-3.33/src/nix-vector-routing/examples/nix-simple.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/nix-vector-routing/examples/nix-simple.cc	2021-07-14 10:31:07.000000000 -0700
@@ -23,19 +23,89 @@
 #include "ns3/ipv4-list-routing-helper.h"
 #include "ns3/ipv4-nix-vector-helper.h"
 
-/*
- *  Simple point to point links:
+/**
+ * This program demonstrates two types of
+ * trace output that are available:
+ * 1) Print Routing Table for all the nodes.
+ * 2) Print Routing Path, given source and destination.
  *
- *  n0 -- n1 -- n2 -- n3
- *
- *  n0 has UdpEchoClient 
- *  n3 has UdpEchoServer
- *
- *  n0 IP: 10.1.1.1
- *  n1 IP: 10.1.1.2, 10.1.2.1
- *  n2 IP: 10.1.2.2, 10.1.3.1
- *  n3 IP: 10.1.3.2
+ * Simple point to point links:
+ * \verbatim
+       ________
+      /        \
+    n0 -- n1 -- n2 -- n3
+
+    n0 IP: 10.1.1.1, 10.1.4.1
+    n1 IP: 10.1.1.2, 10.1.2.1
+    n2 IP: 10.1.2.2, 10.1.3.1, 10.1.4.2
+    n3 IP: 10.1.3.2
+   \endverbatim
  *
+ * Route Path for considered cases:
+ * - Source (n0) and Destination (n3)
+ *   It goes from n0 -> n2 -> n3
+ * - Source (n1) and Destination (n3)
+ *   It goes from n1 -> n2 -> n3
+ * - Source (n2) and Destination (n0)
+ *   It goes from n2 -> n0
+ * - Source (n1) and Destination (n1)
+ *   It goes from n1 -> n1
+ * .
+ * \verbatim
+   Expected Routing Path output for above
+   cases (in the output stream):
+   Time: +3s, Nix Routing
+   Route Path: (Node 0 to Node 3, Nix Vector: 101)
+   10.1.4.1 (Node 0)   ---->   10.1.4.2 (Node 2)
+   10.1.3.1 (Node 2)   ---->   10.1.3.2 (Node 3)
+
+   Time: +5s, Nix Routing
+   Route Path: (Node 1 to Node 3, Nix Vector: 101)
+   10.1.2.1 (Node 1)   ---->   10.1.2.2 (Node 2)
+   10.1.3.1 (Node 2)   ---->   10.1.3.2 (Node 3)
+
+   Time: +6s, Nix Routing
+   Route Path: (Node 2 to Node 0, Nix Vector: 10)
+   10.1.4.2 (Node 2)   ---->   10.1.4.1 (Node 0)
+
+   Time: +7s, Nix Routing
+   Route Path: (Node 1 to Node 1, Nix Vector: )
+   10.1.1.2 (Node 1)   ---->   10.1.1.2 (Node 1)
+
+   Node: 0, Time: +8s, Local time: +8s, Nix Routing
+   NixCache:
+   Destination     NixVector
+   10.1.3.2        101
+   Ipv4RouteCache:
+   Destination     Gateway         Source            OutputDevice
+   10.1.3.2        10.1.4.2        10.1.4.1          2
+
+   Node: 1, Time: +8s, Local time: +8s, Nix Routing
+   NixCache:
+   Destination     NixVector
+   10.1.3.2        101
+   Ipv4RouteCache:
+   Destination     Gateway         Source            OutputDevice
+   10.1.3.2        10.1.2.2        10.1.2.1          2
+
+   Node: 2, Time: +8s, Local time: +8s, Nix Routing
+   NixCache:
+   Destination     NixVector
+   10.1.1.1        10
+   Ipv4RouteCache:
+   Destination     Gateway         Source            OutputDevice
+   10.1.1.1        10.1.4.1        10.1.4.2          3
+   10.1.3.2        10.1.3.2        10.1.3.1          2
+   10.1.4.1        10.1.4.1        10.1.4.2          3
+
+   Node: 3, Time: +8s, Local time: +8s, Nix Routing
+   NixCache:
+   Destination     NixVector
+   10.1.4.1        010
+   Ipv4RouteCache:
+   Destination     Gateway         Source            OutputDevice
+   10.1.4.1        10.1.3.1        10.1.3.2          1
+   \endverbatim
  */
 
 using namespace ns3;
@@ -47,7 +117,7 @@
 {
   CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
-  
+
   LogComponentEnable ("UdpEchoClientApplication", LOG_LEVEL_INFO);
   LogComponentEnable ("UdpEchoServerApplication", LOG_LEVEL_INFO);
 
@@ -62,6 +132,10 @@
   nodes34.Add (nodes23.Get (1));
   nodes34.Create (1);
 
+  NodeContainer nodes13;
+  nodes13.Add (nodes12.Get (0));
+  nodes13.Add (nodes34.Get (0));
+
   PointToPointHelper pointToPoint;
   pointToPoint.SetDeviceAttribute ("DataRate", StringValue ("5Mbps"));
   pointToPoint.SetChannelAttribute ("Delay", StringValue ("2ms"));
@@ -78,9 +152,11 @@
   NetDeviceContainer devices12;
   NetDeviceContainer devices23;
   NetDeviceContainer devices34;
+  NetDeviceContainer devices13;
   devices12 = pointToPoint.Install (nodes12);
   devices23 = pointToPoint.Install (nodes23);
   devices34 = pointToPoint.Install (nodes34);
+  devices13 = pointToPoint.Install (nodes13);
 
   Ipv4AddressHelper address1;
   address1.SetBase ("10.1.1.0", "255.255.255.0");
@@ -88,10 +164,13 @@
   address2.SetBase ("10.1.2.0", "255.255.255.0");
   Ipv4AddressHelper address3;
   address3.SetBase ("10.1.3.0", "255.255.255.0");
+  Ipv4AddressHelper address4;
+  address4.SetBase ("10.1.4.0", "255.255.255.0");
 
-  address1.Assign (devices12);
-  address2.Assign (devices23);
-  Ipv4InterfaceContainer interfaces = address3.Assign (devices34);
+  Ipv4InterfaceContainer interfaces12 = address1.Assign (devices12);
+  Ipv4InterfaceContainer interfaces23 = address2.Assign (devices23);
+  Ipv4InterfaceContainer interfaces34 = address3.Assign (devices34);
+  Ipv4InterfaceContainer interfaces13 = address4.Assign (devices13);
 
   UdpEchoServerHelper echoServer (9);
 
@@ -99,7 +178,7 @@
   serverApps.Start (Seconds (1.0));
   serverApps.Stop (Seconds (10.0));
 
-  UdpEchoClientHelper echoClient (interfaces.GetAddress (1), 9);
+  UdpEchoClientHelper echoClient (interfaces34.GetAddress (1), 9);
   echoClient.SetAttribute ("MaxPackets", UintegerValue (1));
   echoClient.SetAttribute ("Interval", TimeValue (Seconds (1.)));
   echoClient.SetAttribute ("PacketSize", UintegerValue (1024));
@@ -108,8 +187,13 @@
   clientApps.Start (Seconds (2.0));
   clientApps.Stop (Seconds (10.0));
 
-  // Trace routing tables
+  // Trace routing paths for different source and destinations.
   Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper> ("nix-simple.routes", std::ios::out);
+  nixRouting.PrintRoutingPathAt (Seconds (3), nodes12.Get (0), interfaces34.GetAddress (1), routingStream);
+  nixRouting.PrintRoutingPathAt (Seconds (5), nodes12.Get (1), interfaces34.GetAddress (1), routingStream);
+  nixRouting.PrintRoutingPathAt (Seconds (6), nodes23.Get (1), interfaces12.GetAddress (0), routingStream);
+  nixRouting.PrintRoutingPathAt (Seconds (7), nodes12.Get (1), interfaces12.GetAddress (1), routingStream);
+  // Trace routing tables
   nixRouting.PrintRoutingTableAllAt (Seconds (8), routingStream);
 
   Simulator::Run ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/nix-vector-routing/examples/nix-simple-multi-address.cc ns-3.34/src/nix-vector-routing/examples/nix-simple-multi-address.cc
--- ns-3.33/src/nix-vector-routing/examples/nix-simple-multi-address.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/nix-vector-routing/examples/nix-simple-multi-address.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,231 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 NITK Surathkal
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Ameya Deshpande <ameyanrd@outlook.com>
+ *
+ */
+
+#include "ns3/core-module.h"
+#include "ns3/network-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/point-to-point-module.h"
+#include "ns3/applications-module.h"
+#include "ns3/ipv4-static-routing-helper.h"
+#include "ns3/ipv4-list-routing-helper.h"
+#include "ns3/ipv4-nix-vector-helper.h"
+
+/**
+ * This program demonstrates a routing and
+ * PrintRoutingPath example for multiple interface
+ * addresses.
+ *
+ * Simple point-to-point links:
+ * \verbatim
+    n0 -- n1 -- n2 -- n3
+
+    From t = 0s onwards,
+    n0 (right) IP: 10.1.1.1, 10.2.1.1
+    n1 (left)  IP: 10.1.1.2, 10.2.1.2
+    n1 (right) IP: 10.1.2.1
+    n2 (left)  IP: 10.1.2.2
+    n2 (right) IP: 10.1.3.1
+    n3 (left)  IP: 10.1.3.2
+
+    From t = +5s onwards (new address subnet
+    added for n2 and n3),
+    n0 (right) IP: 10.1.1.1, 10.2.1.1
+    n1 (left)  IP: 10.1.1.2, 10.2.1.2
+    n1 (right) IP: 10.1.2.1
+    n2 (left)  IP: 10.1.2.2
+    n2 (right) IP: 10.1.3.1, 10.2.3.1
+    n3 (left)  IP: 10.1.3.2, 10.2.3.2
+
+   \endverbatim
+ *
+ * Cases considered:
+ * 1. For UDP Echo Application:
+ *  - At t = +2s, Path from n0 to n3 (10.1.3.2).
+ * 2. For PrintRoutingPath, 10.1.1.3
+ *  - At t = +3s, Path from n0 to n1 (10.2.1.2).
+ *  - At t = +7s, Path from n0 to n3 (10.2.3.2).
+ *
+ * \verbatim
+   Logging output:
+   At time +2s client sent 1024 bytes to 10.1.3.2 port 9
+   At time +2.01106s server received 1024 bytes from 10.1.1.1 port 49153
+   At time +2.01106s server sent 1024 bytes to 10.1.1.1 port 49153
+   At time +2.02212s client received 1024 bytes from 10.1.3.2 port 9
+
+   Output in nix-simple-multi-address.routes:
+   Time: +3s, Nix Routing
+   Route Path: (Node 0 to Node 1, Nix Vector: 0)
+   10.2.1.1 (Node 0)   ---->   10.2.1.2 (Node 1)
+
+   Node: 0, Time: +4s, Local time: +4s, Nix Routing
+   NixCache:
+   Destination     NixVector
+   10.1.3.2        011
+   10.2.1.2        0
+   Ipv4RouteCache:
+   Destination     Gateway         Source            OutputDevice
+   10.1.3.2        10.1.1.2        10.1.1.1          1
+
+   Node: 1, Time: +4s, Local time: +4s, Nix Routing
+   NixCache:
+   Ipv4RouteCache:
+   Destination     Gateway         Source            OutputDevice
+   10.1.1.1        10.1.1.1        10.1.1.2          1
+   10.1.3.2        10.1.2.2        10.1.2.1          2
+
+   Node: 2, Time: +4s, Local time: +4s, Nix Routing
+   NixCache:
+   Ipv4RouteCache:
+   Destination     Gateway         Source            OutputDevice
+   10.1.1.1        10.1.2.1        10.1.2.2          1
+   10.1.3.2        10.1.3.2        10.1.3.1          2
+
+   Node: 3, Time: +4s, Local time: +4s, Nix Routing
+   NixCache:
+   Destination     NixVector
+   10.1.1.1        000
+   Ipv4RouteCache:
+   Destination     Gateway         Source            OutputDevice
+   10.1.1.1        10.1.3.1        10.1.3.2          1
+
+   Node: 0, Time: +6s, Local time: +6s, Nix Routing
+   NixCache:
+   Ipv4RouteCache:
+
+   Node: 1, Time: +6s, Local time: +6s, Nix Routing
+   NixCache:
+   Ipv4RouteCache:
+
+   Node: 2, Time: +6s, Local time: +6s, Nix Routing
+   NixCache:
+   Ipv4RouteCache:
+
+   Node: 3, Time: +6s, Local time: +6s, Nix Routing
+   NixCache:
+   Ipv4RouteCache:
+
+   Time: +7s, Nix Routing
+   Route Path: (Node 0 to Node 3, Nix Vector: 011)
+   10.1.1.1 (Node 0)   ---->   10.1.1.2 (Node 1)
+   10.1.2.1 (Node 1)   ---->   10.1.2.2 (Node 2)
+   10.1.3.1 (Node 2)   ---->   10.2.3.2 (Node 3)
+ * \endverbatim
+ */
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("NixSimpleExample");
+
+int
+main (int argc, char *argv[])
+{
+  CommandLine cmd (__FILE__);
+  cmd.Parse (argc, argv);
+
+  LogComponentEnable ("UdpEchoClientApplication", LOG_LEVEL_INFO);
+  LogComponentEnable ("UdpEchoServerApplication", LOG_LEVEL_INFO);
+
+  NodeContainer nodes12;
+  nodes12.Create (2);
+
+  NodeContainer nodes23;
+  nodes23.Add (nodes12.Get (1));
+  nodes23.Create (1);
+
+  NodeContainer nodes34;
+  nodes34.Add (nodes23.Get (1));
+  nodes34.Create (1);
+
+  PointToPointHelper pointToPoint;
+  pointToPoint.SetDeviceAttribute ("DataRate", StringValue ("5Mbps"));
+  pointToPoint.SetChannelAttribute ("Delay", StringValue ("2ms"));
+
+  NodeContainer allNodes = NodeContainer (nodes12, nodes23.Get (1), nodes34.Get (1));
+
+  // NixHelper to install nix-vector routing
+  // on all nodes
+  Ipv4NixVectorHelper nixRouting;
+  InternetStackHelper stack;
+  stack.SetRoutingHelper (nixRouting); // has effect on the next Install ()
+  stack.Install (allNodes);
+
+  NetDeviceContainer devices12;
+  NetDeviceContainer devices23;
+  NetDeviceContainer devices34;
+  devices12 = pointToPoint.Install (nodes12);
+  devices23 = pointToPoint.Install (nodes23);
+  devices34 = pointToPoint.Install (nodes34);
+
+  Ipv4AddressHelper address1;
+  address1.SetBase ("10.1.1.0", "255.255.255.0");
+  Ipv4AddressHelper address2;
+  address2.SetBase ("10.1.2.0", "255.255.255.0");
+  Ipv4AddressHelper address3;
+  address3.SetBase ("10.1.3.0", "255.255.255.0");
+  Ipv4AddressHelper address4;
+  address4.SetBase ("10.2.1.0", "255.255.255.0");
+  Ipv4AddressHelper address5;
+  address5.SetBase ("10.2.3.0", "255.255.255.0");
+
+  address1.Assign (devices12);
+  address2.Assign (devices23);
+  Ipv4InterfaceContainer interfaces34 = address3.Assign (devices34);
+  Ipv4InterfaceContainer interfaces12 = address4.Assign (devices12);
+
+  UdpEchoServerHelper echoServer (9);
+
+  ApplicationContainer serverApps = echoServer.Install (nodes34.Get (1));
+  serverApps.Start (Seconds (1.0));
+  serverApps.Stop (Seconds (10.0));
+
+  // Set the destination address as 10.1.3.2
+  UdpEchoClientHelper echoClient (interfaces34.GetAddress (1), 9);
+  echoClient.SetAttribute ("MaxPackets", UintegerValue (1));
+  echoClient.SetAttribute ("Interval", TimeValue (Seconds (1.)));
+  echoClient.SetAttribute ("PacketSize", UintegerValue (1024));
+
+  ApplicationContainer clientApps = echoClient.Install (nodes12.Get (0));
+  clientApps.Start (Seconds (2.0));
+  clientApps.Stop (Seconds (10.0));
+
+  // Trace routing paths for different source and destinations.
+  Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper> ("nix-simple-multi-address.routes", std::ios::out);
+  // Check the path from n0 to n1 (10.1.3.2).
+  nixRouting.PrintRoutingPathAt (Seconds (3), nodes12.Get (0), interfaces12.GetAddress (1, 1), routingStream);
+  // Trace routing tables.
+  nixRouting.PrintRoutingTableAllAt (Seconds (4), routingStream);
+  // Assign address5 addresses to n2 and n3.
+  // n2 gets 10.2.3.1 and n3 gets 10.2.3.2 on the same interface.
+  Simulator::Schedule(Seconds (5), &Ipv4AddressHelper::Assign, &address5, devices34);
+
+  // Trace routing tables.
+  // Notice that NixCache and Ipv4RouteCache becomes empty for each node.
+  // This happens because new addresses are added at t = +5s, due to which
+  // existing caches get flushed.
+  nixRouting.PrintRoutingTableAllAt (Seconds (6), routingStream);
+
+  // Check the path from n0 to n3 (10.2.3.2).
+  nixRouting.PrintRoutingPathAt (Seconds (7), nodes12.Get (0), Ipv4Address ("10.2.3.2"), routingStream);
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+  return 0;
+}
\ No newline at end of file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/nix-vector-routing/examples/wscript ns-3.34/src/nix-vector-routing/examples/wscript
--- ns-3.33/src/nix-vector-routing/examples/wscript	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/nix-vector-routing/examples/wscript	2021-07-14 10:31:07.000000000 -0700
@@ -8,3 +8,7 @@
     obj = bld.create_ns3_program('nms-p2p-nix',
                                  ['point-to-point', 'applications', 'internet', 'nix-vector-routing'])
     obj.source = 'nms-p2p-nix.cc'
+
+    obj = bld.create_ns3_program('nix-simple-multi-address',
+                                 ['point-to-point', 'applications', 'internet', 'nix-vector-routing'])
+    obj.source = 'nix-simple-multi-address.cc'
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/nix-vector-routing/helper/ipv4-nix-vector-helper.cc ns-3.34/src/nix-vector-routing/helper/ipv4-nix-vector-helper.cc
--- ns-3.33/src/nix-vector-routing/helper/ipv4-nix-vector-helper.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/nix-vector-routing/helper/ipv4-nix-vector-helper.cc	2021-07-14 10:31:07.000000000 -0700
@@ -47,4 +47,19 @@
   node->AggregateObject (agent);
   return agent;
 }
+
+void
+Ipv4NixVectorHelper::PrintRoutingPathAt (Time printTime, Ptr<Node> source, Ipv4Address dest, Ptr<OutputStreamWrapper> stream, Time::Unit unit)
+{
+  Simulator::Schedule (printTime, &Ipv4NixVectorHelper::PrintRoute, source, dest, stream, unit);
+}
+
+void
+Ipv4NixVectorHelper::PrintRoute (Ptr<Node> source, Ipv4Address dest, Ptr<OutputStreamWrapper> stream, Time::Unit unit)
+{
+  Ptr<Ipv4NixVectorRouting> rp = Ipv4RoutingHelper::GetRouting <Ipv4NixVectorRouting> (source->GetObject<Ipv4> ()->GetRoutingProtocol ());
+  NS_ASSERT (rp);
+  rp->PrintRoutingPath (source, dest, stream, unit);
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/nix-vector-routing/helper/ipv4-nix-vector-helper.h ns-3.34/src/nix-vector-routing/helper/ipv4-nix-vector-helper.h
--- ns-3.33/src/nix-vector-routing/helper/ipv4-nix-vector-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/nix-vector-routing/helper/ipv4-nix-vector-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -47,8 +47,10 @@
   /**
    * \brief Construct an Ipv4NixVectorHelper from another previously 
    * initialized instance (Copy Constructor).
+   *
+   * \param o object to copy
    */
-  Ipv4NixVectorHelper (const Ipv4NixVectorHelper &);
+  Ipv4NixVectorHelper (const Ipv4NixVectorHelper &o);
 
   /**
    * \returns pointer to clone of this Ipv4NixVectorHelper 
@@ -66,6 +68,22 @@
   */
   virtual Ptr<Ipv4RoutingProtocol> Create (Ptr<Node> node) const;
 
+  /**
+   * \brief prints the routing path for a source and destination at a particular time.
+   * If the routing path does not exist, it prints that the path does not exist between
+   * the nodes in the ostream.
+   * \param printTime the time at which the routing path is supposed to be printed.
+   * \param source the source node pointer to start traversing
+   * \param dest the IPv4 destination address
+   * \param stream the output stream object to use
+   * \param unit the time unit to be used in the report
+   *
+   * This method calls the PrintRoutingPath() method of the
+   * Ipv4NixVectorRouting for the source and destination to provide
+   * the routing path at the specified time.
+   */
+  void PrintRoutingPathAt (Time printTime, Ptr<Node> source, Ipv4Address dest, Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S);
+
 private:
   /**
    * \brief Assignment operator declared private and not implemented to disallow
@@ -75,6 +93,20 @@
   Ipv4NixVectorHelper &operator = (const Ipv4NixVectorHelper &);
 
   ObjectFactory m_agentFactory; //!< Object factory
+
+  /**
+   * \brief prints the routing path for the source and destination. If the routing path
+   * does not exist, it prints that the path does not exist between the nodes in the ostream.
+   * \param source the source node pointer to start traversing
+   * \param dest the IPv4 destination address
+   * \param stream the output stream object to use
+   * \param unit the time unit to be used in the report
+   *
+   * This method calls the PrintRoutingPath() method of the
+   * Ipv4NixVectorRouting for the source and destination to provide
+   * the routing path.
+   */
+  static void PrintRoute (Ptr<Node> source, Ipv4Address dest, Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S);
 };
 } // namespace ns3
 
